/*************************************************************
Copyright (c) 2008

Benjamin Thaut. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions
     and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions
     and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY BENJAMIN THAUT "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

web: www.benjamin-thaut.de
*************************************************************/
#ifndef _CAMERA_H_
#define _CAMERA_H_
#include "thtypes.h"

class camera {
  protected:
    vec4 Pos1;
    vec4 Pos2;
    vec4 Up;
    vec4 Dir;
    float Rotation;
    bool ReCalc;
    float *CameraMatrix;
  public:
    camera();
    ~camera();
    void SetRotation(float Degrees);
    void SetFrom(float x,float y,float z);
    void SetFrom(vec4 vFrom);
    void SetTo(float x,float y,float z);
    void SetTo(vec4 vTo);
    void ChangeFrom(float x,float y,float z);
    void ChangeTo(float x,float y,float z);
    void Move(float x,float y,float z);
    void Set(float x,float y,float z);
    virtual void Call();
    vec4 GetFrom();
    vec4 GetTo();
    float* GetCameraMatrix();
    vec4 GetViewDir();
    vec4 GetUp();
    float GetRotation();

    void SaveToFile(const char* filename);
    void LoadFromFile(const char* filename);
};

#endif
