/*************************************************************
Copyright (c) 2008

Benjamin Thaut. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions
     and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions
     and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY BENJAMIN THAUT "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

web: www.benjamin-thaut.de
*************************************************************/
#ifndef _FBO_H_
#define _FBO_H_
#include "GLee.h"

#define TH_DEPTH_BUFFER             0x0001
#define TH_STENCIL_BUFFER           0x0002
#define TH_COLOR0                   0x0004
#define TH_COLOR1                   0x0008
#define TH_COLOR2                   0x0010
#define TH_COLOR3                   0x0020
#define TH_COLOR4                   0x0040
#define TH_COLOR5                   0x0080
#define TH_COLOR6                   0x0100
#define TH_COLOR7                   0x0200
#define TH_COLOR8                   0x0400
#define TH_DEPTH_BUFFER_TEXTURE_16  0x0800
#define TH_DEPTH_BUFFER_TEXTURE_24  0x1000
#define TH_DEPTH_BUFFER_TEXTURE_32  0x2000

#define TH_RGB8             0x01
#define TH_RGB16            0x02
#define TH_RGB16F           0x03
#define TH_RGBA8            0x04
#define TH_RGBA16           0x05
#define TH_RGBA16F          0x06

class FrameBufferTexture2D {
  private:
    GLuint fbo;
    GLuint DepthBuffer;
    bool bDepthBufferTexture;
    GLuint StencilBuffer;
    GLuint ColorBuffer0;
    GLuint ColorBuffer1;
    GLuint ColorBuffer2;
    GLenum Result;
    char *lpcErrorMessage;
    int iWidth;
    int iHeight;

  public:
    FrameBufferTexture2D(int Width, int Height, int Options, int Format);
    ~FrameBufferTexture2D();
    void Use();
    void Unuse();
    void SwitchTo();
    void Bind(short buff);
    void Bind(short buff,short num);
    void BindToShader(short buff, short num);
    void SetTarget(short num);
    char* Error();
};

class FrameBufferCubeMap{
  private:
    GLuint fbo;
    GLuint DepthBuffer;
    GLuint CubeMap;
    GLenum Result;
    char *lpcErrorMessage;
    int iWidth;
    int iHeight;

  public:
    FrameBufferCubeMap(int Width, int Height, int Options, int Format);
    ~FrameBufferCubeMap();
    void Use();
    void Unuse();
    void SwitchTo();
    //void SetTarget(short num);
    void Bind();
    void Bind(short num);
    char* Error();
};

#endif
