/*************************************************************
Copyright (c) 2008

Benjamin Thaut. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions
     and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions
     and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY BENJAMIN THAUT "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

web: www.benjamin-thaut.de
*************************************************************/
#ifndef _INSTANCING_H_
#define _INSTANCING_H_
#include "vertexbuffer.h"
#include "shader.h"
#include <vector>

typedef std::vector<float> InstanceMatType;

class InstancedVertexBuffer{
  protected:
    VertexBuffer *vbuffer;
    int iMaxInstances;
    std::vector<InstanceMatType*> Mats;
    Shader *ShaderInUse;

  public:
    ~InstancedVertexBuffer();
    bool SetInstanceGroup(int num, mat4a *array, int count);
    int AddInstanceGroup(mat4a *array, int count);
    virtual bool InitDraw(int options, Shader *ptr)=0;
    void DeInitDraw();
    virtual void Draw(int group)=0;
};

class InstancedVertexBufferFallback : public InstancedVertexBuffer {
  public:
    InstancedVertexBufferFallback(VertexBuffer *ptr, int MaxInstances);
    ~InstancedVertexBufferFallback();
    void Draw(int group);
    bool InitDraw(int options, Shader *ptr);
};

class InstancedVertexBufferExtension : public InstancedVertexBuffer {
  public:
    InstancedVertexBufferExtension(VertexBuffer *ptr);
    void Draw(int group);
    bool InitDraw(int options, Shader *ptr);
};

#endif
