#ifndef _MY3D_H_
#define _MY3D_H_
#include <GL/glu.h>

#define mats_per_object 5
#define filename_length 12
#define mode_read_type 0
#define mode_count_digits 1
#define mode_read_value 2

struct TextureImage												// Create A Structure
{
	GLubyte	*imageData;										// Image Data (Up To 32 Bits)
	GLuint	bpp;											// Image Color Depth In Bits Per Pixel.
	GLuint	width;											// Image Width
	GLuint	height;											// Image Height
	GLuint	texID;											// Texture ID Used To Select A Texture
};

struct vertex{
  float x;
  float y;
  float z;
};

struct vertex_normal{
  vertex g_groups[32];
};

struct texturecoord{
  float x;
  float y;
};

struct face{
  unsigned short a;
  unsigned short b;
  unsigned short c;
  unsigned short mat;
};

struct material{
  char name[255];
  char mapname[filename_length];
  unsigned short textur;
  float r;
  float g;
  float b;
};

struct g_group{
  unsigned short *used_faces;
  unsigned short anz_used_faces;
};

struct object{
  char name[255];
  unsigned short vert_anz;
  unsigned short face_anz;
  unsigned short mat_anz;
  face *faces;
  vertex *vertices;
  texturecoord *texcoords;
  bool has_texturecoords;
  material materials[mats_per_object];
  vertex *normals;
  vertex_normal *vertex_normals;
  g_group g_groups[32];
};

#endif
