/*************************************************************
Copyright (c) 2008

Benjamin Thaut. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions
     and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions
     and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY BENJAMIN THAUT "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

web: www.benjamin-thaut.de
*************************************************************/
#ifndef _SCRIPTPARSER_H_
#define _SCRIPTPARSER_H_
#include <vector>

#define TH_INT      0
#define TH_FLOAT    1
#define TH_OPERATOR 2

#define TH_OP_ADD  0 // +
#define TH_OP_SUB  1 // -
#define TH_OP_MUL  2 // *
#define TH_OP_DIV  3 // /
#define TH_OP_AND  4 // &&
#define TH_OP_OR   5 // ||
#define TH_OP_B    8 // >
#define TH_OP_BE   9 // >=
#define TH_OP_S   10 // <
#define TH_OP_SE  11 // <=
#define TH_OP_E   12 // ==
#define TH_OP_NE  13 // !=
#define TH_OP_NOT 14 // !

struct ScriptVar {
  char *name;
  char type;
  union {
    float fData;
    int iData;
  };
};

typedef std::vector<ScriptVar> ScriptVarVector;

struct ScriptVarChain {
  ScriptVarChain *next,*prev;
  ScriptVar Var;
};

bool ParseExpression(const char *expr, ScriptVarVector *OptionStack, ScriptVarVector *VarStack, ScriptVar& result);
bool ParseAssigment(const char *expr, ScriptVarVector *OptionStack, ScriptVarVector *VarStack);


#endif
