/*************************************************************
Copyright (c) 2008

Benjamin Thaut. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions
     and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions
     and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY BENJAMIN THAUT "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

web: www.benjamin-thaut.de
*************************************************************/
#ifndef _TEXTURE_H_
#define _TEXTURE_H_
#include "GLee.h"
#include "thtypes.h"

#define TH_LINEAR    0x01
#define TH_NEAREST   0x02
#define TH_CLAMP_S   0x04
#define TH_CLAMP_T   0x08
#define TH_MIPMAPS   0x10

class Texture2D {
  private:
    GLubyte *lpData;
    GLuint uiBitsPerPixel;
    GLuint uiWidth;
    GLuint uiHeight;
    GLuint gluiTextureId;
    GLenum gleDataFormat;
    GLenum gleInternalFormat;
  public:
    Texture2D();
    ~Texture2D();
    bool LoadTGA(const char *filename, char options);
    bool CreateEmpty(int width, int height, GLenum DataFormat, GLenum InternalFormat, char options);
    bool Insert(int iXto, int iYto, int iSrcWidth, int iSrcHeight, unsigned char *buffer);
    bool Reupload();
    void Bind(short num);
    void Bind();
    void BindToShader(int num);
    vec4 GetPixel(float x, float y);
    vec4 GetPixel(vec2 Coords);
    vec4 GetPixel(int x, int y);
    unsigned int GetWidth();
    unsigned int GetHeight();
};

#endif
