/*************************************************************
Copyright (c) 2008

Benjamin Thaut. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions
     and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions
     and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY BENJAMIN THAUT "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

web: www.benjamin-thaut.de
*************************************************************/
#ifndef _THTYPES_H_
#define _THTYPES_H_
#include "vektoren.h"

struct vertexposv4{
  unsigned int uiNum;
  vec4 v4Pos;
  vec4 *v4Normals;
  vec4 *v4Tangents;
  vec4 *v4Binormals;
  unsigned short *usUsedIn;
  unsigned short usTimesUsed;
};

struct vertexv4{
  unsigned int uiNum;
  vertexposv4 *Pos;
  vec2 v2Texcoord;
};

struct facev4{
  union {
    struct {
      vertexv4 *a;
      vertexv4 *b;
      vertexv4 *c;
    };
    vertexv4* vertices[3];
  };
  vec4 v4Normal;
  vec4 v4Tangent;
  vec4 v4Binormal;
  vec4 v4AveragePos;
  unsigned int uiNumGGroup;
};

struct edgev4{
  vertexv4 *vertices[2];
};

struct facev4con{
  struct facev4con *con[3];
  bool bVisible;
};

struct ggroup{
  unsigned int *uiFaces;
  unsigned int uiNumFaces;
};

#endif
