/*************************************************************
Copyright (c) 2008

Benjamin Thaut. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted
provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions
     and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions
     and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY BENJAMIN THAUT "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

web: www.benjamin-thaut.de
*************************************************************/
#include "object.h"
#include "vektoren.h"

Object::Object(){
  v4Position.x = v4Position.y = v4Position.z = 0.0f;
  v4Position.w = 1.0f;
  v3Rotation.x = v3Rotation.y = v3Rotation.z = 0.0f;
  Recalc();
}

void Object::Recalc(){
  Matrix = TranslationMatrix(v4Position) * RotationMatrixXYZ(v3Rotation);
}

void Object::SetPosition(vec4 Position){
  v4Position = Position;
  v4Position.w = 1.0f;
  Recalc();
}

void Object::SetPosition(float x, float y, float z){
  v4Position.x = x;
  v4Position.y = y;
  v4Position.z = z;
  v4Position.w = 1.0f;
  Recalc();
}

void Object::SetRotation(vec3 Rotation){
  v3Rotation = Rotation;
  Recalc();
}
